#include "stdafx.h"
#include "HttpAsyncRequest.h"

#include "NhConversion.h"

#define URLBUFFER_SIZE		(4096)

void CHttpAsyncRequest::Clear()
{
	if( m_hRequest )
	{
		WinHttpSetStatusCallback( m_hRequest, NULL, 0, NULL );
		WinHttpCloseHandle(m_hRequest);
		m_hRequest = NULL;
	}
	if( m_hConnect )
	{
		WinHttpCloseHandle(m_hConnect);
		m_hConnect = NULL;
	}
	m_ssRead = std::stringstream();
}

void CHttpAsyncRequest::SendRequest( HINTERNET hSession,
									 const tstring& tstrUrl,
									 const tstring& tstrParameter,
									 BOOL bIsHttpVerbPost )
{
	// ڑ͏Ȃ
	if( IsConnected() )
	{
		return;
	}

	// Cvbg`FbN
	if( NULL == hSession
	 || 0 == tstrUrl.length() )
	{
		RequestFailed( _T("URLs") );
		return;
	}

	// ϐ
	wstring wstrServer;
	INTERNET_PORT nPort = 0;
	wstring wstrVerb;
	wstring wstrObjectName;
	tstring wstrHeaders;
	std::string strOptional;

	// URL
	URL_COMPONENTS urlcomponents;
	ZeroMemory( &urlcomponents, sizeof(URL_COMPONENTS) );
	urlcomponents.dwStructSize = sizeof(URL_COMPONENTS);
	WCHAR wszHostName[URLBUFFER_SIZE];
	WCHAR wszUrlPath[URLBUFFER_SIZE];
	urlcomponents.lpszHostName	= wszHostName;
	urlcomponents.lpszUrlPath	= wszUrlPath;
	urlcomponents.dwHostNameLength	= URLBUFFER_SIZE;
	urlcomponents.dwUrlPathLength	= URLBUFFER_SIZE;
	if( !WinHttpCrackUrl(	tstrUrl.c_str(),
							0,
							0,
							&urlcomponents ) )
	{	// URL̉͂Ɏs
		RequestFailed( _T("URL͂Ɏs") );
		return;
	}

	wstrServer		= urlcomponents.lpszHostName;
	wstrObjectName	= urlcomponents.lpszUrlPath;
	nPort			= urlcomponents.nPort;

	// HTTPHTTPSȊO
	DWORD dwOpenRequestFlag = (INTERNET_SCHEME_HTTPS == urlcomponents.nScheme) ? WINHTTP_FLAG_SECURE : 0;

	// POSTGET
	if( bIsHttpVerbPost )
	{	// POST
		wstrVerb	= L"POST";
		wstrHeaders	= L"Content-Type: application/x-www-form-urlencoded";
		if( 0 != tstrParameter.length() )
		{	// p[^AMIvVf[^ɕϊ
			char* pszOptional = NhT2M( tstrParameter.c_str() );	// charɕϊ
			strOptional = pszOptional;
			free( pszOptional );
		}
	}
	else
	{	// GET
		wstrVerb	= L"GET";
		wstrHeaders	= L"";
		if( 0 != tstrParameter.length() )
		{	// IuWFNgƃp[^u?vŘA
			WCHAR* pwszBuffer = NhT2W( tstrParameter.c_str() );
			wstrObjectName += L"?" + wstring(pwszBuffer);
			free( pwszBuffer );
		}
	}

	// HTTPڑ
	m_hConnect = WinHttpConnect( hSession,
								 wstrServer.c_str(),
								 nPort,
								 0 );
	if( NULL == m_hConnect )
	{
		RequestFailed( _T("HTTPڑɎs") );
		return;
	}
	
	// HTTPڑJ
	m_hRequest = WinHttpOpenRequest( m_hConnect,
									 wstrVerb.c_str(),
									 wstrObjectName.c_str(),
									 NULL,
									 WINHTTP_NO_REFERER,
									 WINHTTP_DEFAULT_ACCEPT_TYPES,
									 dwOpenRequestFlag );
	if( NULL == m_hRequest )
	{
		RequestFailed( _T("HTTPڑJɎs") );
		return;
	}

	// R[obN֐̐ݒ
	if( WINHTTP_INVALID_STATUS_CALLBACK == WinHttpSetStatusCallback( m_hRequest,
																	 (WINHTTP_STATUS_CALLBACK)InternetCallback,
																	  WINHTTP_CALLBACK_FLAG_ALL_COMPLETIONS | WINHTTP_CALLBACK_FLAG_REDIRECT,
																	  NULL) )
	{
		RequestFailed( _T("R[obN̐ݒɎs") );
		return;
	}

	// NGXg̑M
	if( !WinHttpSendRequest( m_hRequest, 
							 wstrHeaders.c_str(),
							 wstrHeaders.length(),
							 (LPVOID)strOptional.c_str(),
							 strOptional.length() * sizeof(char),
							 strOptional.length() * sizeof(char),
							 (DWORD_PTR)this) )
	{
		RequestFailed( _T("NGXg̑MɎs") );
		return;
	}
}

void CALLBACK CHttpAsyncRequest::InternetCallback( HINTERNET hInternet,
												   DWORD_PTR dwContext,
												   DWORD dwInternetStatus,
												   LPVOID lpvStatusInformation,
												   DWORD dwStatusInformationLength )
{
	assert( dwContext );
	if( 0 == dwContext )
	{
		return;
	}

	CHttpAsyncRequest* pHttpRequest = reinterpret_cast<CHttpAsyncRequest*>( dwContext );
	pHttpRequest->OnCallback( dwInternetStatus,
								   lpvStatusInformation,
								   dwStatusInformationLength );
}

void CHttpAsyncRequest::OnCallback( DWORD dwInternetStatus,
									LPVOID lpvStatusInformation,
									DWORD dwStatusInformationLength )
{
	switch( dwInternetStatus )
	{
		case WINHTTP_CALLBACK_STATUS_SENDREQUEST_COMPLETE:
			// NGXg̑M
			OutputDebugString( _T("InternetStatus = SENDREQUEST_COMPLETE\n") );
			{
				// X|X̓̑ҋ@
				if( !WinHttpReceiveResponse( m_hRequest, NULL ) )
				{
					RequestFailed( _T("WinHttpReceiveResponse()Ɏs") );
					return;
				}
			}
			break;
		case WINHTTP_CALLBACK_STATUS_HEADERS_AVAILABLE:
			// wb_[̎擾\
			OutputDebugString( _T( "InternetStatus = HEADERS_AVAILABLE\n") );
			{
				DWORD dwStatusCode = 0;
				DWORD dwStatusCodeSize = sizeof(DWORD);
				if( !WinHttpQueryHeaders( m_hRequest,
										  WINHTTP_QUERY_STATUS_CODE | WINHTTP_QUERY_FLAG_NUMBER,	// Xe[^XR[hDWORD^Ŏ擾B
										  WINHTTP_HEADER_NAME_BY_INDEX,	// wb_[̃|C^
										  &dwStatusCode,				// obt@[
										  &dwStatusCodeSize,			// obt@[TCY
										  WINHTTP_NO_HEADER_INDEX))		// ŏɔwb_[̂ݎo
				{
					RequestFailed( _T("WinHttpQueryHeaders()Ɏs") );
					return;
				}
				if( HTTP_STATUS_OK != dwStatusCode )
				{
					RequestFailed( _T("Xe[^XR[hƂOKԂĂȂ") );
					return;
				}

				// X|Xf[^f[^₢킹
				if( !WinHttpQueryDataAvailable( m_hRequest, NULL ) )
				{
					RequestFailed( _T("WinHttpQueryDataAvailable()Ɏs") );
					return;
				}
			}
			break;
		case WINHTTP_CALLBACK_STATUS_DATA_AVAILABLE:
			// f[^̎擾\
			OutputDebugString( _T( "InternetStatus = DATA_AVAILABLE\n") );
			{
				DWORD dwSize = *((LPDWORD)lpvStatusInformation);
				if( 0 == dwSize )
				{	// ǂݍݏI->R[obNI
					RequestSucceeded();
					return;
				}

				// X|Xf[^ǂݍ
				DWORD dwLength = dwSize + 1;
				char* pszBuffer = (char*)malloc( dwLength * sizeof(char) );
				if( !WinHttpReadData( m_hRequest,
									  pszBuffer,		// obt@[
									  dwSize,			// ǂݍރoCg
									  NULL ) )
				{
					free( pszBuffer );
					RequestFailed( _T("WinHttpReadData()Ɏs") );
					return;
				}
				// obt@[͉͂ɏIB
				// WinHttpReadData()OɁAR[obN֐WINHTTP_CALLBACK_STATUS_READ_COMPLETEŌĂ΂B
				// obt@[́AR[obN֐WINHTTP_CALLBACK_STATUS_READ_COMPLETEɏB
			}
			break;
		case WINHTTP_CALLBACK_STATUS_READ_COMPLETE:
			OutputDebugString( _T( "InternetStatus = READ_COMPLETE\n") );
			if( lpvStatusInformation
			 && dwStatusInformationLength )
			{
				char* pszBuffer = (char*)lpvStatusInformation;
				pszBuffer[dwStatusInformationLength] = '\0';
				m_ssRead << pszBuffer;
				free( pszBuffer );

				// X|Xf[^f[^₢킹
				if( !WinHttpQueryDataAvailable( m_hRequest, NULL ) )
				{
					RequestFailed( _T("WinHttpQueryDataAvailable()Ɏs") );
					return;
				}
			}
			break;
		case WINHTTP_CALLBACK_STATUS_REDIRECT:
			OutputDebugString( _T( "InternetStatus = REDIRECT\n") );
			break;
		case WINHTTP_CALLBACK_STATUS_REQUEST_ERROR:
			OutputDebugString( _T( "InternetStatus = REQUEST_ERROR\n") );
			RequestFailed( _T("InternetStatus = REQUEST_ERROR") );
			return;
		case WINHTTP_CALLBACK_STATUS_INTERMEDIATE_RESPONSE:
			OutputDebugString( _T( "InternetStatus = INTERMEDIATE_RESPONSE\n") );
			break;
		default:
			OutputDebugString( _T( "Unknown InternetStatus \n") );
			RequestFailed( _T("Unknown InternetStatus") );
			return;
	}
}
